## START: Set by rpmautospec
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 4;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

%global srcname strictyaml

%global forgeurl https://github.com/crdoconnor/%{srcname}/
%global tag %{version}

Name:           python-%{srcname}
Version:        1.4.4
%forgemeta
Release:        %autorelease
Summary:        Parses and validates a restricted subset of YAML

License:        MIT
URL:            http://hitchdev.com/%{srcname}
Source0:        %{forgesource}
# https://github.com/crdoconnor/strictyaml/issues/152
Source1:        https://sourceforge.net/p/ruamel-yaml/code/ci/0.16.13/tree/LICENSE?format=raw#/LICENSE-ruamel-yaml

BuildArch:      noarch

BuildRequires:  python3-devel
BuildRequires:  pyproject-rpm-macros

# We do not attempt to build the documentation, since it requires an
# idiosyncratic build system (see https://hitchdev.com/) that is hopelessly
# entangled with the idea of downloading dependencies from PyPI. An offline
# build would be nearly impossible.

%global common_description %{expand:
StrictYAML is a type-safe YAML parser that parses and validates a restricted
subset of the YAML specification.

Priorities:

  • Beautiful API
  • Refusing to parse the ugly, hard to read and insecure features of YAML like
    the Norway problem.
  • Strict validation of markup and straightforward type casting.
  • Clear, readable exceptions with code snippets and line numbers.
  • Acting as a near-drop in replacement for pyyaml, ruamel.yaml or poyo.
  • Ability to read in YAML, make changes and write it out again with comments
    preserved.
  • Not speed, currently.}

%description %{common_description}


%package -n     python3-%{srcname}
Summary:        %{summary}

# Upstream bundled/vendored a slightly older version of ruamel.yaml after an
# update with API changes was too difficult to support. This is intended to be
# a temporary workaround until the vendored library can be replaced with a
# custom parser for StrictYAML. See
# https://github.com/crdoconnor/strictyaml/issues/151 for discussion, and
# strictyaml/ruamel/__init__.py for version information.
Provides:       bundled(python3dist(ruamel-yaml)) = 0.16.13

%description -n python3-%{srcname} %{common_description}


%prep
%forgesetup
cp -p '%{SOURCE1}' .


%generate_buildrequires
%pyproject_buildrequires -r


%build
%pyproject_wheel


%install
%pyproject_install
%pyproject_save_files %{srcname}


%check
# There are no tests. (If there were, it would be as hard to run them as it is
# to build the documentation.)
%py3_check_import %{srcname}


%files -n python3-%{srcname} -f %{pyproject_files}
%license LICENSE.txt LICENSE-ruamel-yaml
%doc CHANGELOG.md
%doc README.md


%changelog
* Tue Jul 27 2021 Benjamin A. Beasley <code@musicinmybrain.net> 1.4.4-4
- Move %generate_buildrequires after %prep to make the spec file easier to
  follow

* Wed Jul 21 2021 Benjamin A. Beasley <code@musicinmybrain.net> 1.4.4-3
- Add import “smoke test”

* Sun Jun 20 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 1.4.4-1
- Update to 1.4.4 (closes RHBZ#1974003)
- The package now bundles ruamel.yaml 0.16.13 until the author can supply a
  custom parser to replace it.

* Fri Jun 04 2021 Python Maint <python-maint@redhat.com> - 1.4.0-2
- Rebuilt for Python 3.10

* Mon Mar 29 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 1.4.0-1
- Update to 1.4.0
- Start using pyproject-rpm-macros

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.3.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Tue Jan 19 14:10:19 EST 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 1.3.2-1
- Update to 1.3.2

* Tue Jan 12 11:40:57 EST 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 1.3.1-1
- Update to 1.3.1

* Sun Jan 10 13:51:32 EST 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 1.3.0-1
- Update to 1.3.0

* Sat Jan  2 16:01:07 EST 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 1.2.0-1
- Update to version 1.2.0

* Thu Nov 26 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 1.1.0-3
- Remove conditionals for Fedora 32 and older

* Thu Nov 26 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 1.1.0-2
- Remove EPEL conditionals from Fedora spec file

* Tue Nov 24 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 1.1.0-1
- Initial package

